/*
 *  Copyright 2002-2015 Barcelona Supercomputing Center (www.bsc.es)
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
#include<iostream>
#include<fstream>
#include<string>
#include"SimpleGAT.h"

using namespace std;

void increment(file fileName) {
    cout << "INIT TASK" << endl;
    cout << "Param: " << fileName << endl;
    // Read value
    char initialValue;
    ifstream fis (fileName);
    if (fis.is_open()) {        
        if (fis >> initialValue) {
            fis.close();
        } else {
            cerr << "[ERROR] Unable to read final value" << endl;
            fis.close();
        }
        fis.close();
    } else {
        cerr << "[ERROR] Unable to open file" << endl;
    }
    
    // Increment
    cout << "INIT VALUE: " << initialValue << endl;
    int finalValue = ((int)(initialValue) - (int)('0')) + 1;
    cout << "FINAL VALUE: " << finalValue << endl;
    
    // Write new value
    ofstream fos (fileName);
    if (fos.is_open()) {
        fos << finalValue << endl;
        fos.close();
    } else {
        cerr << "[ERROR] Unable to open file" << endl;
    }
    cout << "END TASK" << endl;
}
